unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  ActiveX, StrUtils, Buttons;//, DB, ADODB;

type
  TSyncJetFRM = class(TForm)
    FileSRC: TEdit;
    FileDST: TEdit;
    OpenDialog1: TOpenDialog;
    bFileSRC: TButton;
    bFileDST: TButton;
    bStartSync: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    FileMDW: TEdit;
    Label3: TLabel;
    EUser: TEdit;
    Label4: TLabel;
    EPwd: TEdit;
    Label5: TLabel;
    bFileMDW: TButton;
    lab: TLabel;

    procedure bStartSyncClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bFileOpen(var ctl: TEdit);
    procedure bFileSRCClick(Sender: TObject);
    procedure bFileDSTClick(Sender: TObject);
    procedure bFileMDWClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure aaa(st: string);
  Function CreateDAOInstance(var DAOInstance: Variant): boolean;
  function SyncDB(fileSRC, fileDST: string; FileMDW: string = ''; UserDef: string = ''; pwd: string=''):Boolean;
  Function ObjExists(ObjName: string; var objColl: Variant; ObjVid: string = ''): Boolean;
  Function Compact_BD(tmpDir, strPathDB: String): Boolean;
const
  Engines: array[0..2] of string = ('DAO.DBEngine.36', 'DAO.DBEngine.35', 'DAO.DBEngine');

var
  SyncJetFRM: TSyncJetFRM;
  DAODBEngine: Variant;
implementation

uses ComObj;

{$R *.dfm}

procedure TSyncJetFRM.bStartSyncClick(Sender: TObject);
var
  SaveCursor: TCursor;
begin
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  lab.Caption := '...';
  if SyncDB(FileSRC.Text ,FileDST.Text,FileMDW.text, EUser.Text, EPwd.Text)=True then
    lab.Caption := ''
  else lab.Caption := ' ';
  Screen.Cursor := SaveCursor; //    

end;

procedure aaa(st: string);
begin
  ShowMessage(st);
end;

function ObjExists(ObjName: string; var objColl: Variant; ObjVid: string = ''): Boolean;
{,         
 
 
 
}
 var nm: string;
 begin
    try
      nm := objcoll.item[objName].name;
    except
      on E: Exception do begin
        //ShowMessage( e.Message); //ErrorDialog(E.Message, E.HelpContext);
        ObjExists := False;
        Exit;
      end;
    end;
    ObjExists := True;
end;

function CreateDAOInstance(var DAOInstance: variant):boolean;
var
  i: integer;
const Engines: array[0..2] of string = ('DAO.DBEngine.36', 'DAO.DBEngine.35', 'DAO.DBEngine');

  function CheckClass(OLEClassName: string): boolean;
  var Res: HResult;
  begin
    Result := CoCreateInstance(ProgIDToClassID(OLEClassName), nil, CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER, IDispatch, Res) = S_OK;
  end;

begin
  for i := 0 to 2 do
  begin
    if CheckClass(Engines[i]) = True then
    begin
      DAOInstance := CreateOleObject(Engines[i]);
      CreateDAOInstance := True;
      exit;
    end;
  end;
  CreateDAOInstance := False;
end;

function SyncDB(fileSRC, fileDST: string; FileMDW: string = ''; UserDef: string = ''; pwd: string=''):Boolean;
var
  dbS, dbD: Variant;
  tdfsSRC, tdfsDST: Variant;
  tdfSRC, tdfDST: Variant;
  FldsSRC, FldsDST: Variant;
  FldSRC, FldDST: Variant;
  indxS, indxD: Variant;
  indxsS, indxsD: Variant;
  prpSRC, prpDST: Variant;
  PrpsSRC, PrpsDST: Variant;
//  SrcFile, DstFile, s: string;
  arS : array of string; //   -
  kolTab, i, j, k: Integer; //   -

label mEx;
begin
  SyncDB := False;
  if CreateDAOInstance(DAODBEngine)=False then begin
    ShowMessage('    DAO!!!');
    Exit;
  end;

  If FileMDW <> '' then begin
    DAODBEngine.SystemDB := FileMDW;
    DAODBEngine.DefaultUser := UserDef;
    DAODBEngine.DefaultPassword := pwd;
  end;
  dbS := DAODBEngine.OpenDatabase(fileSRC);//, True);
  dbD := DAODBEngine.OpenDatabase(fileDST);//, True);
  tdfsSRC := dbs.TableDefs;

  kolTab := 0;
//  aaa(PChar(IntToStr(tdfs.Count)));
  for i:=0 to tdfsSRC.Count-1 do
  begin
    tdfSRC := tdfsSRC.item[i];
      if ((tdfSRC.Attributes And -2147483646 {dbSystemObject} ) Or
         (tdfSRC.Attributes And 1 {dbHiddenObject} )) = False then
      //      
      begin
         kolTab := kolTab + 1;
         SetLength(arS,kolTab);
         arS[kolTab-1] := tdfsSRC.Item[i].Name;
      end;
  end;
  //aaa (PChar(IntToStr(koltab)));
  if koltab = 0 then goto mEx;
  //    
  tdfsSRC := dbS.TableDefs;
  tdfsDST := dbD.TableDefs; //     -
  For i := Low(arS) To High(arS) do
  begin
    if ObjExists(arS[i], tdfsDST, 'tab') = False then
    begin //    -, 
//      tdfSRC := tdfsSRC.item[arS[i]];
//      tdfDst := dbD.CreateTableDef(arS[i], tdfSRC.Attributes);
//      FldsSRC := tdfSRC.Fields[0];
//      tdfDst.Fields.Append(tdfDst.CreateField(FldsSRC.Name,FldsSRC.type, FldsSRC.Size));
//      tdfsDST.Append(tdfDst);
//      tdfDst.Fields.refresh;

      dbD.Execute('SELECT TOP 1 [' + arS[i] + '].* INTO ' + arS[i] + ' FROM [' + fileSRC + '].' + arS[i]);
      dbD.Execute('DELETE FROM [' + arS[i] + ']');
    end
    else begin
      tdfDst := tdfsDST.item[arS[i]];
      //     , ...
      if ((tdfDST.Attributes And 1073741824{dbAttachedTable}) Or
        (tdfDST.Attributes And 536870912{dbAttachedODBC})) = true then
      begin

        tdfsDST.Delete(arS[i]);//    
//        dbD.CreateTableDef('');

        dbD.Execute('SELECT TOP 1 [' + arS[i] + '].* INTO ' + arS[i] + ' FROM [' + fileSRC + '].' + arS[i]);
        dbD.Execute('DELETE FROM [' + arS[i] + ']');
      end;
    end;
  end;
  tdfsDST.Refresh;

  //     
  For i := Low(arS) To High(arS) do
  begin //  
    //
    tdfSRC := tdfsSRC.item[arS[i]];
    tdfDst := tdfsDST.item[arS[i]];

      FldsSRC := tdfSRC.Fields; //   ( . )
      FldsDST := tdfDST.Fields;

      //   (  )
      for j := 0 to FldsSRC.Count-1 do begin
        FldSRC := FldsSRC.item[j]; //    -
      //    ,   
        if ObjExists(FldSRC.Name, FldsDST) = False then begin
          FldDST := tdfDST.CreateField(FldSRC.Name, FldSRC.Type, FldSRC.Size);
          for k := 0 To FldDST.Properties.Count - 1 do begin
            try
              FldDST.Properties.item[k].Value := FldSRC.Properties.item[FldDST.Properties.item[k].Name].Value;
            except end;
          end;
          FldsDST.Append(FldDST); //  - 
        end;
      end;
      FldsDST.Refresh;

      //  
      for j := 0 to FldsSRC.Count-1 do begin
        FldSRC := FldsSRC.item[j]; //    -
        FldDST := FldsDST.item[FldSRC.name]; //    -
        PrpsDST := FldDST.Properties;
        //   
        for k := 0 To FldSRC.Properties.Count - 1 do begin
          prpSRC := FldSRC.Properties.item[k];
           //  ,   
          If ObjExists(prpSRC.Name, PrpsDST) = False Then begin //    ,   
            try
              prpDST := FldDST.CreateProperty(prpSRC.Name, prpSRC.type, prpSRC.Value);
              PrpsDST.Append(prpDST);
              //aaa(prpSRC.Name);
            except
              //aaa(prpSRC.Name);
            end;
            PrpsDST.Refresh;
          end;
          //  
          try
            PrpsDST.item[prpSRC.Name].Value := prpSRC.Value;
          except
            //aaa(prpSRC.Name);
          end;
        end;
      end;

//if 1=1 then begin
//    
      // ,     
      indxsS := tdfSRC.Indexes;
      indxsD := tdfDST.Indexes;
      for j := 0 to indxsD.Count-1 do begin
        indxD:= indxsD.item[j];
        if ObjExists(indxD.Name, indxsS) = False then begin//  ,
          indxsD.Delete(indxD.Name);
          indxsD.Refresh;
        end;
      end;

      //      
      for j := 0 to indxsS.Count-1 do
      begin
        indxS:= indxsS.item[j];
        //  ,  
        If ObjExists(indxS.Name, indxsD) = False then
        begin
            indxD := tdfDST.CreateIndex(indxS.Name); //  
            // ()    -
            for k := 0 to indxS.Fields.Count-1 do
            begin
              FldSRC := indxS.Fields.item[k];
              try
                indxD.Fields.Append(indxD.CreateField(FldSRC.Name));
              except
                //ShowMessage(e.Message);
                //on E: Exception do ShowMessage(e.Message); //ErrorDialog(E.Message, E.HelpContext);
              end;
            end;
            //     -
            for k := 0 To indxD.Properties.Count - 1 do
            begin
              try
                indxD.Properties.item[k].Value := indxS.Properties.item[indxD.Properties[k].Name].Value;
              except end;
            end;
            indxsD.Append(indxD); //   
          indxsD.Refresh;
        end;

        //     -
        indxD := indxsD.item[indxS.name];

        PrpsDST := indxD.Properties;
        PrpsSRC := indxS.Properties;
        //   
        for k := 0 To PrpsSRC.Count - 1 do
        begin
          prpSRC := PrpsSRC.item[k];
           //  ,   
          If ObjExists(prpSRC.Name, PrpsDST) = False Then
          begin //    ,   
            try
              prpDST := indxD.CreateProperty(prpSRC.Name, prpSRC.Type, prpSRC.Value);
              PrpsDST.Append(prpDST);
            except end;
            PrpsDST.Refresh;
          end;
          //  
          try
            PrpsDST.item[prpSRC.Name].Value := prpSRC.Value;
          except end;
        end;
      end;
//end;
  end;

  SyncDB := True;
//  s := dbs.Name;
//  aaa(PChar(s));

mEx:
  dbS.Close;
  dbD.Close;
//  tdfsSRC := UnAssigned;
  Compact_BD( ExtractFilePath(fileDST),fileDST);
  DAODBEngine := UnAssigned;

end;


Function Compact_BD(tmpDir, strPathDB: String): Boolean;
    //tmpDir -    (     )
    //strPathDB -   
var
  cmpBD, strPath_LDB: string;

begin
  Compact_BD := False;
//  ShowMessage(' ');
  try //  On Error GoTo errPnt
    //    
    if DirectoryExists(tmpDir) = False Then
      if ForceDirectories(tmpDir) = False then Exit;

    //  ldb,    ,   ,     !
    strPath_LDB := strPathDB;
    strPath_LDB := AnsiLeftStr(strPath_LDB, Length(strPath_LDB) - 3) + 'ldb';
    if FileExists(strPath_LDB) = True then begin
      if DeleteFile(strPath_LDB) = False then begin
        ShowMessage(' ' + strPathDB + ' .  ,      '); //, MsgBoxStyle.Critical)
        exit;
      end;
    end;

    cmpBD := tmpDir + 'myCmp1.mdb';
    If FileExists(cmpBD) = True  then begin
      if DeleteFile(cmpBD) = False then begin
        ShowMessage('    ' + cmpBD + '!!!'); //, MsgBoxStyle.Critical)
        Exit;
      end;
    end;

    DAODBEngine.CompactDatabase(strPathDB, cmpBD);
    If FileExists(cmpBD) = True Then begin//   
      DeleteFile(strPathDB); //    
      RenameFile(cmpBD, strPathDB);
      Compact_BD := True;
//      ShowMessage(' ');
    end
    else ShowMessage('  !!!');

  except
    on E: Exception do begin
      ShowMessage(E.Message);
      Compact_BD := False;
      Exit;
    end;
  end;
end;

procedure TSyncJetFRM.bFileOpen(var ctl: TEdit);
begin
  OpenDialog1.Execute;
  if OpenDialog1.FileName='' then exit;
  ctl.Text := OpenDialog1.FileName;
end;

procedure TSyncJetFRM.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
{  try
    ADOConn.connected := True;
    tblTable1.Active := True;

    tblTable1.Insert;
    tblTable1.FieldByName('param').Value := '111';
    tblTable1.Post;

  finally
    tblTable1.active := False;
    ADOConn.connected := False;
  end;
}
end;

procedure TSyncJetFRM.bFileSRCClick(Sender: TObject);
begin
  bFileOpen(FileSRC);
end;

procedure TSyncJetFRM.bFileDSTClick(Sender: TObject);
begin
  bFileOpen(FileDST);
end;

procedure TSyncJetFRM.bFileMDWClick(Sender: TObject);
begin
  OpenDialog1.FilterIndex := 2;
  bFileOpen(Filemdw);
  OpenDialog1.FilterIndex := 1;
end;

end.

